=== debian/changelog ===
gnudatalanguage (1.1.3-1) unstable; urgency=medium

  [ Alexandre Detiste ]
  * replace usage of "py.test-3" compat symlink with canonical "pytest"
  * bump Standards-Version to 4.7.3, drop Priority: tag

  [ Ole Streicher ]
  * New upstream version 1.1.3
  * Rediff patches
  * Rename d/gitlab-ci.yml to d/salsa-ci.yml
  * Adjust d/watch to use the correct artefact
  * Don't manually attach architectur name to Python's GDL.so (Closes: #1127016)

 -- Ole Streicher <olebole@debian.org>  Sat, 28 Feb 2026 11:40:06 +0100
