=== debian/watch ===
Version: 5
Source: https://github.com/gnudatalanguage/gdl/tags
Matching-Pattern: (?:.*?)/releases/tag/v@ANY_VERSION@
Download-Url-Mangle: s|/releases/tag/v@ANY_VERSION@|/releases/download/v$1/gdl-v$1.tar.gz|
